/*
	Button.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSControl.h"
#import "NSButtonCell.h"

@interface NSButton : NSControl
{
}

+ setCellClass:factoryId;

- init;
- initFrame:(NSRect)frameRect;
- initFrame:(NSRect)frameRect title:(NSString *)aString tag:(int)anInt target:anObject action:(SEL)aSelector key:(unsigned short)charCode enabled:(BOOL)flag;
- initFrame:(NSRect)frameRect icon:(NSString *)aString tag:(int)anInt target:anObject action:(SEL)aSelector key:(unsigned short)charCode enabled:(BOOL)flag;

- (NSString *)title;
- setTitle:(NSString *)aString;
- (NSString *)altTitle;
- setAltTitle:(NSString *)aString;
- (NSString *)icon;
- setIcon:(NSString *)iconName;
- (NSString *)altIcon;
- setAltIcon:(NSString *)iconName;
- image;
- setImage:image;
- altImage;
- setAltImage:image;
- (int)iconPosition;
- setIconPosition:(int)aPosition;
- setIcon:(NSString *)iconName position:(int)aPosition;
- setType:(NSButtonType)aType;
- (int)state;
- setState:(int)value;
- (BOOL)isBordered;
- setBordered:(BOOL)flag;
- (BOOL)isTransparent;
- setTransparent:(BOOL)flag;
- setPeriodicDelay:(float)delay andInterval:(float)interval;
- getPeriodicDelay:(float *)delay andInterval:(float *)interval;
- (NSString *)keyEquivalent;
- setKeyEquivalent:(NSString *)characters;
- sound;
- setSound:soundObj;
- display;
- highlight:(BOOL)flag;
- (BOOL)performKeyEquivalent:(NXEvent *)theEvent;
- performClick:sender;
- (BOOL)acceptsFirstMouse;

@end
