/*
	ClipView.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSView.h"
#import "color.h"

@interface NSClipView : NSView
{
    float               backgroundGray;
    id                  docView;
    NSRect              _docRect;
    id                  cursor;
    void               *_private;
    struct __clFlags {
#ifdef __BIG_ENDIAN__
	unsigned int        isGraySet:1;
	unsigned int        _RESERVED:11;
	unsigned int        _onlyUncovered:1;
	unsigned int        _reflectScroll:1;
	unsigned int        _usedByCell:1;
	unsigned int        _scrollClipTo:1;
#else
	unsigned int        _scrollClipTo:1;
	unsigned int        _usedByCell:1;
	unsigned int        _reflectScroll:1;
	unsigned int        _onlyUncovered:1;
	unsigned int        _RESERVED:11;
	unsigned int        isGraySet:1;
#endif
    }                   _clFlags;
}

- initFrame:(NSRect)frameRect;
- setBackgroundGray:(float)value;
- (float)backgroundGray;
- setBackgroundColor:(NXColor)color;
- (NXColor)backgroundColor;
- drawRect:(NSRect)rect;
- setDocView:aView;
- docView;
- (NSRect)documentRect;
- setDocCursor:anObj;
- resetCursorRects;
- (NSRect)documentVisibleRect;
- descendantFrameChanged:sender;
- descendantFlipped:sender;
- setCopyOnScroll:(BOOL)flag;
- setDisplayOnScroll:(BOOL)flag;
- autoscroll:(NXEvent *)theEvent;
- (NSPoint)constrainScroll:(NSPoint)newOrigin;
- rawScroll:(NSPoint)newOrigin;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;
- (void)dealloc;

- rotate:(float)angle;
- rotateTo:(float)angle;
- setDrawRotation:(float)angle;

- awake;
- setFrameOrigin:(NSPoint)_newOrigin;
- setFrameSize:(NSSize)_newSize;
- setBoundsOrigin:(NSPoint)_newOrigin;
- setBoundsSize:(NSSize)_newSize;
- translateOriginToPoint:(NSPoint)_translation;
- scaleUnitSquareToSize:(NSSize)_newUnitSize;

@end

@interface NSView(ClipViewSuperview)
- reflectScroll:aClipView;
- scrollClip:aClipView to:(NSPoint)aPoint;
@end
