/*
	NXColorList.h
	Application Kit, Release 3.0
	Copyright (c) 1988, 1989, 1990, 1991 NeXT, Inc.  All rights reserved. 
*/

#import <Foundation/NSObject.h>
#import <objc/List.h>
#import "color.h"
@class NSArray;

@interface NSColorList : NSObject
{
@private
    char *_name;
    char *_printerType;
    char *_fileName;
    id _hashTable;
    id _colors;
    id _delegate;
    id _editor;
    struct _colorListFlags {
	unsigned int colorsLoaded:1;
	unsigned int editable:1;
	unsigned int hasDeviceSpecificLists:1;
	unsigned int generatesNamedColors:1;
	unsigned int dirty:1;
	unsigned int hasFrozen:1;
	unsigned int :0;
    } _flags;
    id _localNames;
    unsigned _reserved[3];
}

+ (NSArray *)availableColorLists;
+ findColorListNamed:(NSString *)name;
- init;
- initWithName:(NSString *)name;
- initWithName:(NSString *)name fromFile:(NSString *)path;
- freeAndRemoveFile;
- (void)dealloc;
- (NSString *)name;
- (unsigned)colorCount;
- (NSString *)nameOfColorAt:(unsigned)index;
- (void)setColorNamed:(NSString *)colorName color:(NXColor)color;
- (void)removeColorNamed:(NSString *)colorName;
- (NXColor)colorNamed:(NSString *)colorName;
- (NSString *)localizedNameForColorNamed:(NSString *)colorName;
- (BOOL)generatesNamedColors;
- (BOOL)isEditable;
- saveTo:(NSString *)path;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end

@interface NSObject (NXColorListDelegate)
- colorListDidChange:list colorName:(NSString *)colorName;
@end


