/*
	NXEPSImageRep.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSImageRep.h"
#import <objc/List.h>
#import <streams/streams.h>
#import <objc/zone.h>

@interface NSEPSImageRep : NSImageRep
{
    char               *_fileName;
    NSPoint             _bBoxOrigin;
    char               *_memory;
    int                 _epsLen;
    short               _epsOffset;
    short		_reservedShort;
    char               *_otherName;
    int                 _reservedInt;
}

- initFromSection:(NSString *)fileName;
- initFromFile:(NSString *)fileName;
- initFromStream:(NXStream *)stream;

+ (List *)newListFromSection:(NSString *)fileName;
+ (List *)newListFromFile:(NSString *)fileName;
+ (List *)newListFromStream:(NXStream *)stream;
+ (List *)newListFromSection:(NSString *)fileName zone:(NSZone *)zone;
+ (List *)newListFromFile:(NSString *)fileName zone:(NSZone *)zone;
+ (List *)newListFromStream:(NXStream *)stream zone:(NSZone *)zone;

- (BOOL)drawIn:(NSRect)rect;
- (BOOL)draw;
- prepareGState;
- getEPS:(char **)epsString length:(int *)length;
- (NSRect)boundingBox;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- copyFromZone:(NSZone *)zone;
- (void)dealloc;

@end

