/*
	FontPanel.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved.
*/

#import "NSPanel.h"
#import "NSFont.h"

/* Tags of views in the FontPanel */

enum {
    NSFPPreviewButton			= 131,
    NSFPRevertButton			= 130,
    NSFPSetButton			= 132,
    NSFPPreviewField			= 128,
    NSFPSizeField			= 129,
    NSFPSizeTitle			= 133,
    NSFPCurrentField			= 134
};

@interface NSFontPanel : NSPanel
{
    id                  faces;
    id                  families;
    id                  preview;
    id                  current;
    id                  size;
    id                  sizes;
    id                  manager;
    id                  selFont;
    NXFontMetrics      *selMetrics;
    int                 curTag;
    id                  accessoryView;
    char	       *_keyBuffer;
    id                  setButton;
    id                  separator;
    id                  sizeTitle;
    char               *lastPreview;
    struct _fpFlags {
	unsigned int        multipleFont:1;
	unsigned int        dirty:1;
	unsigned int        _RESERVED:11;
	unsigned int        _amPreviewing:1;
	unsigned int        _alwaysPreview:1;
	unsigned int        _dontPreview:1;
    }                   fpFlags;
    unsigned short      _reservedFPshort1;
    long                _lastKeyTime;
    id		        _chooser;
    id		        _titles;
    id		        _previewBox;
}

+ sharedFontPanel;

- accessoryView;
- setAccessoryView:aView;
- textDidEnd:textObject endChar:(unsigned short)endChar;
- textDidGetKeys:textObject isEmpty:(BOOL)flag;
- orderWindow:(int)place relativeTo:(int)otherWin;
- (NSSize)windowWillResize:sender toSize:(NSSize)frameSize;
- setPanelFont:fontObj isMultiple:(BOOL)flag;
- panelConvertFont:fontObj;
- (BOOL)worksWhenModal;
- (BOOL)isEnabled;
- setEnabled:(BOOL)flag;

@end
