/*
	Menu.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSPanel.h"
#import <objc/zone.h>

@interface NSMenu : NSPanel
{
    id                  supermenu;
    id                  matrix;
    id                  attachedMenu;
    NSPoint             lastLocation;
    id                  reserved;
    struct _menuFlags {
#ifdef __BIG_ENDIAN__
	unsigned int        sizeFitted:1;
	unsigned int        autoupdate:1;
	unsigned int        attached:1;
	unsigned int        tornOff:1;
	unsigned int        wasAttached:1;
	unsigned int        wasTornOff:1;
	unsigned int        _RESERVED:6;
	unsigned int	    _templateType:2;
	unsigned int        _isServicesMenu:1;
	unsigned int        _changeTitle:1;
#else
	unsigned int        _changeTitle:1;
	unsigned int        _isServicesMenu:1;
	unsigned int	    _templateType:2;
	unsigned int        _RESERVED:6;
	unsigned int        wasTornOff:1;
	unsigned int        wasAttached:1;
	unsigned int        tornOff:1;
	unsigned int        attached:1;
	unsigned int        autoupdate:1;
	unsigned int        sizeFitted:1;
#endif
    }                   menuFlags;
}

+ setMenuZone:(NSZone *)aZone;
+ (NSZone *)menuZone;

- init;
- initTitle:(NSString *)aTitle;

- addItem:(NSString *)aString action:(SEL)aSelector keyEquivalent:(NSString *)characters;
- setSubmenu:aMenu forItem:aCell;
- itemList;
- setItemList:aMatrix;
- display;
- sizeToFit;
- setFrameTopLeftPoint:(NSPoint)_newTopLeft;
- windowMoved:(NXEvent *)theEvent;
- close;
- update;
- setAutoupdate:(BOOL)flag;
- findCellWithTag:(int)aTag;
- (NSPoint)locationForSubmenu:aSubmenu;
- mouseDown:(NXEvent *)theEvent;
- rightMouseDown:(NXEvent *)theEvent;
- awake;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end

@interface NSMenu(SubmenuDummyAction)
- submenuAction:sender;
@end
