/*
	Panel.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSWindow.h"

/*
 * In the following two functions, msg may be a printf-like message with
 * the arguments tacked onto the end.  Thus, to get a '%' in your message,
 * you must use '%%'
 */

extern int NSRunAlertPanel(NSString *title, NSString *msg, NSString *defaultButton, NSString *alternateButton, NSString *otherButton, ...);

extern int NSRunLocalizedAlertPanel(NSString *table, NSString *title, NSString *msg, NSString *defaultButton, NSString *alternateButton, NSString *otherButton, ...);

extern id NSGetAlertPanel(NSString *title, NSString *msg, NSString *defaultButton, NSString *alternateButton, NSString *otherButton, ...);

extern void NSReleaseAlertPanel(id panel);

/*
 * NXRunAlertPanel() return values (also returned by runModalSession: when
 * the modal session is run with a panel returned by NXGetAlertPanel()).
 */

#define NSAlertDefaultReturn		1
#define NSAlertAlternateReturn	0
#define NSAlertOtherReturn		-1
#define NSAlertErrorReturn		-2

/* Tags for common controls in Panels */

#define NSOKButton	1
#define NSCancelButton	0

@interface NSPanel : NSWindow
{
}

- initContent:(NSRect)contentRect style:(int)aStyle backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag;
- init;
- (BOOL)commandKey:(NXEvent *)theEvent;
- keyDown:(NXEvent *)theEvent;
- (BOOL)isFloatingPanel;
- setFloatingPanel:(BOOL)flag;
- (BOOL)doesBecomeKeyOnlyIfNeeded;
- setBecomeKeyOnlyIfNeeded:(BOOL)flag;
- (BOOL)worksWhenModal;
- setWorksWhenModal:(BOOL)flag;

@end
