/*
	Speaker.h
	Application Kit, Release 2.0
	Copyright (c) 1988, NeXT, Inc.  All rights reserved. 
*/

#import <Foundation/NSObject.h>
#import "obsoleteListener.h"
#import <mach/message.h>
#import <mach/port.h>


@interface Speaker : NSObject
{
    port_t              sendPort;
    port_t              replyPort;
    int                 sendTimeout;
    int                 replyTimeout;
    id                  delegate;
    int                 _reservedSpeaker1;
    int                 _reservedSpeaker2;
}

- init;
- (void)dealloc;
- delegate;
- setDelegate:anObject;
- (port_t)sendPort;
- setSendPort:(port_t)aPort;
- (port_t)replyPort;
- setReplyPort:(port_t)aPort;
- (int)sendTimeout;
- setSendTimeout:(int)ms;
- (int)replyTimeout;
- setReplyTimeout:(int)ms;
- (int)performRemoteMethod:(NSString *)msgSelector;
- (int)performRemoteMethod:(NSString *)msgSelector with:(const char *)data length:(int)numBytes;
- (int)selectorRPC:(NSString *)msgSelector paramTypes:(char *)params, ...;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

/* use [Application workspace] instead of these messages unless you need to send them to the port of a specific app */
- (int)sendOpenFileMsg:(NSString *)fullPath ok:(int *)flag andDeactivateSelf:(BOOL)doDeact;
- (int)sendOpenTempFileMsg:(NSString *)fullPath ok:(int *)flag andDeactivateSelf:(BOOL)doDeact;
- (int)openFile:(NSString *)fullPath ok:(int *)flag;
- (int)openTempFile:(NSString *)fullPath ok:(int *)flag;

- (int)msgQuit:(int *)flag;
- (int)msgCalc:(int *)flag;
- (int)msgDirectory:(char * const *)fullPath ok:(int *)flag;
- (int)msgVersion:(char * const *)aString ok:(int *)flag;
- (int)msgFile:(char * const *)fullPath ok:(int *)flag;
- (int)msgPrint:(const char *)fullPath ok:(int *)flag;
- (int)msgSelection:(char * const *)bytes length:(int *)len asType:(const char *)aType ok:(int *)flag;
- (int)msgSetPosition:(const char *)aString posType:(NSMsgPositionType)aPosition andSelect:(int)sflag ok:(int *)flag;
- (int)msgPosition:(char * const *)aString posType:(int *)anInt ok:(int *)flag;
- (int)msgCopyAsType:(const char *)aType ok:(int *)flag;
- (int)msgCutAsType:(const char *)aType ok:(int *)flag;
- (int)msgPaste:(int *)flag;

@end
