#import <objc/objc.h>

typedef enum {
    NSStreamStart,
    NSStreamCurrent,
    NStreamEnd
} NSStreamSeekMode;

/*
This is the protocol an object which wants to be spell-checked must respond to.  Therfore, it is the protocol the delegate of NXSpellServer uses to access the text (see below).

This is a purely NeXTstep-encoding protocol, so 16-bit entities (in the KANJI system) will have to be converted to an obvious break character (e.g. space) in the Text object.  In other words, one byte in the buffer must equal one character (it does not support multiple bytes per character).  All formattting, etc., should obviously be completely stripped out.  Only the actual characters should come through this protocol.
*/

@protocol NXReadOnlyTextStream
- openTextStream;
- (BOOL)seekToCharacterAt:(int)offset relativeTo:(int)seekMode;
- (int)readCharacters:(char *)buffer count:(int)count;
- (int)currentCharacterOffset;
- (BOOL)isAtEOTS;
- closeTextStream;
@end
